//
//  ShowLineEChartNode.m
//  CXLYText
//
//  Created by zlh on 2019/3/15.
//  Copyright © 2019 山东畅行信息技术有限公司. All rights reserved.
//

#import "ShowLineEChartNode.h"
#import <JavaScriptCore/JavaScriptCore.h>

@interface ShowLineEChartNode ()<UIWebViewDelegate>
@property (nonatomic, strong) ASDisplayNode *bgNode;
@property (nonatomic,strong) UIWebView *echartWebView;
@property (nonatomic, strong) NSString *htmlString;
@end

@implementation ShowLineEChartNode

- (instancetype)initWithFrame:(CGRect)frame html:(NSString*)htmlString{
    self = [super init];
    if (self) {
        self.frame = frame;
        self.htmlString = htmlString;
        [self createNodeUI];
    }
    return self;
}

- (void)createNodeUI{
    self.bgNode = [[ASDisplayNode alloc] init];
    self.bgNode.frame = CGRectMake(0, 0, self.frame.size.width, self.frame.size.height);
    self.bgNode.style.preferredSize = CGSizeMake(self.frame.size.width, self.frame.size.height);
    [self addSubnode:self.bgNode];

    /** 柱状图 */
    self.echartWebView = [[UIWebView alloc]initWithFrame:CGRectMake(0 , 0, self.view.frame.size.width, self.view.frame.size.height)];
    self.echartWebView.delegate = self;
    self.echartWebView.scrollView.scrollEnabled = NO;
    [self.bgNode.view addSubview:self.echartWebView];

    NSString *filePath = [[NSBundle mainBundle]pathForResource:@"cykjEcharts" ofType:@"html"];
    NSString *htmlString = [NSString stringWithContentsOfFile:filePath encoding:NSUTF8StringEncoding error:nil];
    [self.echartWebView loadHTMLString:htmlString baseURL:[NSURL URLWithString:filePath]];

}

#pragma mark- UIWebViewDelegate

- (void)webViewDidStartLoad:(UIWebView *)webView {
    NSLog(@"data : %@",self.htmlString);
}

- (void)webViewDidFinishLoad:(UIWebView *)webView {
    //油耗统计
    NSString *jsStr = [NSString stringWithFormat:@"initFuelConsumptionStatisticsWithLineEcharts('echarts','%@','%@')",@"8月,9月,10月,11月,12月,1月",@"9.7,10.5,12,12.9,11.9,11.9"];

    //油耗曲线
    NSString *jsStr1 = [NSString stringWithFormat:@"initFuelConsumptionCurveWithLineEcharts('echarts','%@','%@')",@"8月,9月,10月,11月,12月,1月",@"9.7,10.5,12,12.9,11.9,11.9"];

    //油耗对比
    NSString *jsStr2 = [NSString stringWithFormat:@"initFuelConsumptionCurveComparisonWithLineEcharts('echarts','%@','%@','%@','%@')",@"8月,9月,10月,11月,12月,1月",@"9.7,10.5,12,12.9,11.9,11.9",@"10.2,11.8,10,9.9,10.3,11",@"13232"];

    //油耗曲线
    NSString *jsStr3 = [NSString stringWithFormat:@"initCostStatisticsWithBarEcharts('echarts','%@','%@')",@"8月,9月,10月,11月,12月,1月",@"509.7,1000.5,1200,1002.9,3702.62,1100.9"];

    JSContext *context = [self.echartWebView valueForKeyPath:@"documentView.webView.mainFrame.javaScriptContext"];

//    context[@"log"] = ^(NSString *str){
//        NSLog(@"log:%@",str);
//    };

    [context evaluateScript:[NSString stringWithFormat:@"initWidthAndHeight(%f,%f)",self.frame.size.width-16,self.frame.size.height-10]];
    [context evaluateScript:self.htmlString];

}

- (void)webView:(UIWebView *)webView didFailLoadWithError:(NSError *)error{

}

- (ASLayoutSpec *)layoutSpecThatFits:(ASSizeRange)constrainedSize{
    ASStackLayoutSpec *spec = [ASStackLayoutSpec stackLayoutSpecWithDirection:ASStackLayoutDirectionHorizontal spacing:0 justifyContent:ASStackLayoutJustifyContentCenter alignItems:ASStackLayoutAlignItemsCenter children:@[self.bgNode]];
    return spec;
}



@end
